<script setup lang="ts">
import MergeRequestCard from "@/components/organisms/card/horizontal-card/MergeRequest/MergeRequestCard.vue";
import {computed, onMounted, ref} from "vue";
import MergeRequest from "@/entities/MergeRequest/MergeRequest";
import {useMergeRequestListStore} from "@/stores/MergeRequest/MergeRequestListStore";
import Flex from "@/components/atoms/container/Flex.vue";
import AutoComplete, {AutoCompleteCompleteEvent, AutoCompleteItemSelectEvent} from "primevue/autocomplete";
import Repository from "@/entities/Repository/Repository";
import SearchCard from "@/components/organisms/card/SearchCard.vue";
import {usePreferencesStore} from "@/stores/Preferences/PreferencesStore";
import MainTemplate from "@/components/templates/MainTemplate.vue";
import ColumnList from "@/components/organisms/list/ColumnList.vue";
import {MergeRequestApiHandler} from "@/handlers/MergeRequestApiHandler";
import {RepositoryApiHandler} from "@/handlers/RepositoryApiHandler";
import SelectButton from "primevue/selectbutton";
import {useSnackbarStore} from "@/stores/Snackbar/SnackbarStore";

// Handler

const repositoryHandler = new RepositoryApiHandler();
const mergeRequestHandler = new MergeRequestApiHandler();

// Stores

const mergeRequestList = useMergeRequestListStore();
const preferences = usePreferencesStore();
const snackbar = useSnackbarStore();

// Constants

const processedAsOption = [
  {
    name: 'Toutes',
    key: 'all',
    filter: null,
    filter_value: null,
  },
  {
    name: 'Non traitées',
    key: 'not_processed',
    filter: 'exists[processedAt]',
    filter_value: false,
  },
  {
    name: 'Traitées',
    key: 'processed',
    filter: 'exists[processedAt]',
    filter_value: true,
  },
]

const mergedAsOption = [
  {
    name: 'Toutes',
    key: 'all',
    filter: null,
    filter_value: null,
  },
  {
    name: 'Non mergées',
    key: 'not_merged',
    filter: 'exists[mergedAt]',
    filter_value: false,
  },
  {
    name: 'Mergées',
    key: 'merged',
    filter: 'exists[mergedAt]',
    filter_value: true,
  },
]

// Refs

const filteredRepositories = ref([]);

const hasAlreadySearched: ref<Boolean> = ref(false);
const searchValue: ref<Repository> = ref(preferences.getSelectedRepository());
const filterByRepository = computed<null | Repository>({
  get(): null | Repository {
    return preferences.getSelectedRepository();
  },
  set(repo: Repository) {
    return preferences.saveSelectedRepository(repo);
  }
});
const filterByProcessed: ref<Array<any>> = ref(processedAsOption[1]);
const filterByMerged: ref<Array<any>> = ref(mergedAsOption[0]);

// Action

const processMergeRequest = async (mergeRequest: MergeRequest) => {
  mergeRequest.processedAt = new Date();
  try {
    const updatedMergeRequest = await mergeRequestHandler.update(mergeRequest);
    let hasProcessedFilter = filterByProcessed.value.key !== 'not_processed';

    if (hasProcessedFilter) {
      mergeRequestList.replaceMergeRequest(mergeRequest, updatedMergeRequest);
    } else {
      mergeRequestList.removeMergeRequest(mergeRequest);
    }
  } catch (e) {
    snackbar.createMessagesFromError(e);
  }
}

const updateMergeRequest = async (mergeRequest: MergeRequest) => {
  try {
    await mergeRequestHandler.update(mergeRequest);
  } catch (e) {
    snackbar.createMessagesFromError(e);
  }
}

const search = () => {
  if (null === filterByRepository.value) {
    return;
  }

  let processedFilter = filterByProcessed.value;
  let mergedFilter = filterByMerged.value;

  const filters = {
    repository: filterByRepository.value?.uri,
    'exists[closedAt]': false
  };

  if (processedFilter.key !== 'all') {
    filters[processedFilter.filter] = processedFilter.filter_value;
  }

  if (mergedFilter.key !== 'all') {
    filters[mergedFilter.filter] = mergedFilter.filter_value;
  }

  mergeRequestHandler
      .list(filters)
      .then((mergeRequest: Array<MergeRequest>) => {
        mergeRequestList.mergeRequests = mergeRequest;
      })

  hasAlreadySearched.value = true;
}

const searchRepository = (event: AutoCompleteCompleteEvent) => {
  const search = event.query.toLowerCase();
  repositoryHandler.list({'global_search': search}).then((repositories) => {
    filteredRepositories.value = repositories;
  });
}

onMounted(search);

</script>

<template>
  <MainTemplate>
    <ColumnList>
      <template #left>
        <Flex class="justify-center">
          <SearchCard :onSubmit="search">
            <AutoComplete
                v-model="searchValue"
                :suggestions="filteredRepositories"
                optionLabel="name"
                placeholder="Dépôts distant"
                dropdown
                @complete="searchRepository"
                inputClass="w-full"
                :inputProps="{required: true, autofocus: true}"
                @itemSelect="(event: AutoCompleteItemSelectEvent) => filterByRepository = event.value"
            />
            <SelectButton
                v-model="filterByProcessed"
                :options="processedAsOption"
                optionLabel="name"
                placeholder="Traitement"
                :invalid="filterByProcessed === null"
            />
            <SelectButton
                v-model="filterByMerged"
                :options="mergedAsOption"
                optionLabel="name"
                placeholder="Merge"
                :invalid="filterByMerged === null"
            />
          </SearchCard>
        </Flex>
      </template>
      <MergeRequestCard
          v-if="mergeRequestList.mergeRequests.length > 0"
          v-for="(mergeRequest) of mergeRequestList.mergeRequests"
          :key="'merge_request_' + mergeRequest.code"
          :mergeRequest="mergeRequest"
          :processMergeRequestHandler="async () => await processMergeRequest(mergeRequest)"
          :updateMergeRequestHandler="async () => await updateMergeRequest(mergeRequest)"
      />
      <span v-else>
      {{ hasAlreadySearched ? 'Aucun résultat trouvé' : 'Veuillez faire une première recherche' }}
    </span>
    </ColumnList>
  </MainTemplate>
</template>
